//【登録場所】 "V2C\script\system\menu.js"
//【内容】 menu.jsのまとめ
/*
ThreadPanel	… レス表示欄ポップアップメニュー
ResNum		… レス番号ポップアップメニュー
Name		… 名前欄ポップアップメニュー
Mail		… メール欄ポップアップメニュー
Time		… 投稿時間ポップアップメニュー
ID			… IDポップアップメニュー
Aux			… 補助情報ポップアップメニュー
Link		… リンクポップアップメニュー
Thumbnail	… サムネイル画像ポップアップメニュー
SelText		… 選択テキストポップアップメニュー

上記のポップアップメニューアイテムを個別にon/offできるスクリプト
TwitterPanel, TwitterUserNameも配列を定義して、popupMenuCreatedにcaseを追加すれば動くはず
SelTextLinkは配列、caseを定義しても動かない可能性あり


===== 配列の説明 =====
○aTP : ポップアップのルートに定義されている文字列の配列

　1つ目の要素
	メニュー項目名
	ポップアップに記述されている項目名と同じものをセットする(括弧等の半角・全角に注意)

　2つ目の要素
	サブメニューのID(と同時にサブメニュー保持のフラグ 0=サブメニューなし、1以上あり
	このIDがサブメニュー用の配列"aTPsub[n]"のnと等しくなるようセットする

　3つ目の要素
	表示・非表示のフラグ。0=非表示、1=表示

○aTPsub : ポップアップに存在するサブメニュー用の配列
　1つ目の要素
	サブメニュー項目名
	サブメニューに記述されている項目名と同じものをセットする(括弧等の半角・全角に注意)

　2つ目の要素
	表示・非表示のフラグ。0=非表示、1=表示
	全てのサブメニューを非表示にする場合は、素直にサブメニューの親を非表示に設定したほうが良いです

※注意事項
	人柱度：高（5段階評価で5）
	ある程度Javascriptが読める人推奨。あと糞みたいなコードを読んでも頭痛のしない人向け
	n|a氏がメニューの項目名を変更すると動かなくなるかも？
	Javascriptに詳しい人が書き直してくれると凄く嬉しい
*/
//【更新日】 2011/02/24
//【元URL】 http://yy61.60.kg/test/read.cgi/v2cj/1252074124/754
//【スクリプト】
// ----- 次の行から -----

// ===== レス表示欄
var aTP = [
// 名前, サブメニューフラグ(0=なし、1以上=サブメニュー配列のキー, 表示フラグ)
['お気に入りに登録',					0,1],
['フォルダに直接登録',					0,1],
['再取得・削除',						1,1],
['開く',								2,1],
['送る',								3,1],
['コピー',								4,1],
['全てを選択',							0,1],
['ラベル（スレッド）',					0,1],
//['ラベル（スレッド）',				5,1],
['オートリロード',						0,1],
['同期再生',							0,1],
['オートスクロール［マウス］',			0,1],
['リンクを含むレスを抽出',				0,1],
['参照＆被参照レスを抽出',				0,1],
['マーカーを引いたレスを抽出',			0,1],
['キーワードを含むレスを抽出',			0,1],
['抽出ダイアログ',						0,1],
['全表示レス',							6,1],
['設定',								7,1],
['スレッドのプロパティ',				0,1]
];
// ===== レス表示欄サブメニュー
var aTPsub = new Array();
// 名前, 表示フラグ(0=非表示, 1=表示)
aTPsub[1] = [
['スレッドの再取得',					1],
['ログを削除',							1],
['ログを削除して閉じる',				1]
];
aTPsub[2] = [
['次スレ検索',							1],
['過去スレを表示する',					1],
['キーワード（2ch）',					1],
['外部ブラウザで開く',					1],
['このスレの板を開く',					1],
['このスレの板を新しいタブで開く',		1],
['このスレの板を外部ブラウザで開く',	1],
['看板の表示',							1],
['ローカルルールの表示',				1],
['SETTING.TXTの表示',					1],
['投稿規約の表示',						1],
['お気に入りタブを表示',				1],
['画像キャッシュ一覧',					1],
['画像表示ウインドウ',					1]
];
aTPsub[3]=[
['お気に入り',							1],
['Jane',								1],
['メインツールバー',					1],
['レス表示ツールバー',					1]
];
aTPsub[4]=[
['タイトルをコピー',					1],
['URLをコピー',							1],
['タイトルとURLをコピー',				1],
['全表示レスをコピー',					1],
['ログファイルのパスをコピー',			1],
['ログファイルをコピー',				1],
['スレッドを登録用にコピー',			1],
];
/*aTPsub[5]=[
['（なし）',1],
['名称未設定0',							1],
['名称未設定1',							1],
['名称未設定2',							1],
['名称未設定3',							1],
['名称未設定4',							1],
['名称未設定5',							1],
['名称未設定6',							1],
['名称未設定7',							1],
['名称未設定8',							1],
['名称未設定9',							1],
['ラベルの設定',						1]
];*/
aTPsub[6]=[
['HTML形式で保存',						1],
['画像を直接保存',						1],
['フォルダに直接保存',					1]
];
aTPsub[7]=[
['連鎖非表示［参照］',					1],
['連鎖非表示［ID］',					1],
['透明非表示',							1],
['個別の透明設定を無視',				1],
['ポップアップで透明レスを表示',		1],
['前回非表示のレスを非表示',			1],
['レス表示の設定',						1],
['背景画像',							1],
['スレタイ変更（ローカルスレッド）',	1]
];

// ===== レス番号
var aRN =[
['このレスにレス',						0,1],
['このレスにレス［本文引用］',			0,1],
['このレスをコピー',					0,1],
['本文をコピー',						0,1],
['本文を引用してコピー',				0,1],
['このレスのURLをコピー',				0,1],
['カスタムコピー',						0,1],
['ラベル',								0,1],
//['ラベル',							1,1],
['ラベルの付いたレスを抽出',			0,1],
['付箋を貼る',							0,1],
['付箋を貼ったレスを抽出',				0,1],
['レスのチェック',						2,1],
['ここから',							3,1],
['被参照数ランキング',					0,1],
['2ch荒らし報告',						4,1],
['ローカルスレッド',					5,1],
['設定',								6,1],
['このレスの内容で新スレ',				0,1]
];
// ===== レス番号サブメニュー
var aRNsub = new Array();
aRNsub[1]=[
['（なし）',							1],
['デフォルト',							1],
['ラベルの設定',						1]
];
aRNsub[2]=[
['このレスをチェック',					1],
['ここからチェック',					1],
['ここからクリア',						1],
['全て反転',							1],
['全てクリア',							1]
];
aRNsub[3]=[
['テキスト選択',						1],
['画像をダウンロード',					1]
];
aRNsub[4]=[
['2ch荒らし報告形式でコピー',			1],
['Boo2008に報告する',					1]
];
aRNsub[5]=[
['このレスを追加（元スレURL付）',		1],
['このレスを追加',						1],
['本文を書き込み欄で置き換える',		1],
['最後のレスをこのレスの前に移動',		1],
['レスを削除',							1]
];
aRNsub[6]=[
['このレスを常に表示',					1],
['このレスを非表示',					1],
['このレスを透明非表示',				1],
['しおりを挟む',						1],
['AAレス',								1],
['非AAレス',							1],
['被参照回数を表示',					1],
['被参照回数によるハイライトの設定',	1]
];
// ===== 名前欄
var aNM=[
['この名前欄をコピー',					0,1],
['非表示の名前に追加',					1,1],
['名前に追加',							0,1],
['名前の削除',							0,1],
['名前・ID・BEの出現回数',				0,1]
];
// ===== 名前欄サブメニュー
var aNMsub = new Array();
aNMsub[1]=[
['スレッド',							1],
['板',									1],
['BBS',									1],
['全体',								1],
['スレッド（トリップのみ）',			1],
['板（トリップのみ）',					1],
['BBS（トリップのみ）',					1],
['全体（トリップのみ）',				1]
];
// ===== Mail欄
var aMA=[
['このメール欄をコピー',				0,1],
['非表示のメールに追加',				1,1],
['メール欄非表示',						0,1]
];
// ===== Mail欄サブメニュー
var aMAsub= new Array();
aMAsub[1] = [
['スレッド',							1],
['板',									1],
['BBS',									1],
['全体',								1]
];
// ===== 投稿時間
var aTM=[
['最終書き込み時刻に設定',				0,1],
['最終書き込み時刻をクリア',			0,1],
['暦を西暦に固定',						0,1]
];
var aTMsub = new Array();
// ===== ID
var aID=[
['このIDをコピー',						0,1],
['非表示のIDに追加',					0,1],
['非表示のIDに追加（透明）',			0,1],
['非表示のIDを解除',					0,1],
['「ログから検索」に追加',				0,1],
['名前・ID・BEの出現回数',				0,1],
['設定',								1,1]
];
// ===== IDサブメニュー
var aIDsub= new Array();
aIDsub[1] = [
['ID出現回数を表示',					1],
['投稿端末を表示',						1],
['背景を着色',							1],
['ID出現回数によるハイライトの設定',	1],
['ID末尾による非表示設定',				1]
];
// ===== 補助情報
var aAX=[
['外部ブラウザで開く',					0,1],
['非表示のBEに追加',					0,1],
['「ログから検索」に追加',				0,1],
['このBeのIDをコピー',					0,1],
['名前・ID・BEの出現回数',				0,1],
['ラベルの設定',						0,1]
];
var aAXsub = new Array();
// ===== Link
var aLK=[
['外部ブラウザで開く',					0,1],
['リンク先をファイルに保存',			0,1],
['リンクのコピー',						0,1],
['ダウンロードの中止',					0,1],
['このリンクを無効化',					0,1],
['NGファイルに追加',					0,1],
['リンク履歴の削除',					0,1],
['プロパティのインポート',				0,1],
['お気に入りタブを表示',				0,1],
['このリンクの板を開く',				0,1],
['モリタポでスレを取得',				0,1],
['画像キャッシュ一覧',					0,1],
['設定',								1,1]
];
// ===== Linkサブメニュー
var aLKsub= new Array();
aLKsub[1] = [
['NGファイル登録の設定・削除',			1],
['NGファイルの一覧',					1],
['NGURLの設定',							1],
['画像保存フォルダの設定',				1],
['フォルダに直接保存の設定',			1]
];
// ===== サムネイル
var aTN=[
['外部ブラウザで開く',					0,1],
['コピー',								1,1],
['このリンクを無効化',					0,1],
['NGファイルに追加',					0,1],
['リンク履歴の削除',					0,1],
['モザイク',							0,1],
['キャッシュ保護',						0,1],
['画像を直接保存',						0,1],
['フォルダに直接保存',					0,1],
//['フォルダに直接保存',				2,1],
['画像を保存',							0,1],
['アニメGIF制御パネル',					0,1],
['画像キャッシュ一覧',					0,1],
['設定',								3,1]
];
// ===== サムネイルサブメニュー
var aTNsub= new Array();
aTNsub[1] = [
['リンクのコピー',						1],
['画像キャッシュのパスをコピー',		1]
];
/*aTNsub[2] = [
['(なし)',								1]
];*/
aTNsub[3] = [
['画像保存フォルダの設定',				1],
['フォルダに直接保存の設定',			1]
];
// ===== 選択テキスト
var aST=[
['Web検索',								0,1],
['Twitter検索',							0,1],
['リンクとして開く',					1,1],
['コピー',								0,1],
['スレタイ・URLとコピー',				0,1],
['レスの抽出',							0,1],
['抽出ポップアップ',					0,1],
['NG Word（本文）に追加',				2,1],
['キーワードに追加',					0,1],
['短文に追加',							0,1],
['選択部分にレス',						0,1],
['マーカーを引く',						0,1],
['マーカーを削除',						0,1],
['NGFiles.txt',							3,1],
['選択範囲のリンク',					4,1]
];
// ===== 選択テキストサブメニュー
var aSTsub= new Array();
aSTsub[1] = [
['UTF-8',								1],
['Shift_JIS',							1],
['EUC-JP',								1]
];
aSTsub[2] = [
['スレッド',							1],
['板',									1],
['BBS',									1],
['全体',								1],
['スレッド（ラベルも設定）',			1],
['板（ラベルも設定）',					1],
['BBS（ラベルも設定）',					1],
['全体（ラベルも設定）',				1]
];
aSTsub[3] = [
['NGFiles.txtに追加',					1],
['NGFiles.txtから削除',					1]
];
aSTsub[4] = [
['画像をダウンロード',					1],
['コピー',								1],
['無効化',								1],
['NGファイルに追加',					1],
['履歴を削除',							1],
['キャッシュを保護',					1],
['キャッシュ保護を解除',				1],
['画像を直接保存',						1],
['フォルダに直接保存',					1],
['画像を保存',							1],
['画像ビューアで開く',					1],
['サムネイル画像を表示',				1],
['サムネイル画像を消去',				1],
['サムネイル画像のキャッシュを削除',	1],
['板・スレッドを開く',					1]
];
function popupMenuCreated(pm,sn){
	switch (sn) {
	case 'ThreadPanel':
		removePopupmenu(pm, aTP, aTPsub);
		break;
	case 'ResNum':
		removePopupmenu(pm, aRN, aRNsub);
		break;
	case 'Name':
		removePopupmenu(pm, aNM, aNMsub);
		break;
	case 'Mail':
		removePopupmenu(pm, aMA, aMAsub);
		break;
	case 'Time':
		removePopupmenu(pm, aTM, aTMsub);
		break;
	case 'ID':
		removePopupmenu(pm, aID, aIDsub);
		break;
	case 'Aux':
		removePopupmenu(pm, aAX, aAXsub);
		break;
	case 'Link':
		removePopupmenu(pm, aLK, aLKsub);
		break;
	case 'Thumbnail':
		removePopupmenu(pm, aTN, aTNsub);
		break;
	case 'SelText':
		removePopupmenu(pm, aST, aSTsub);
		break;
	}
}

function removePopupmenu(pm, ra, ra2){
	for (var i=pm.getComponentCount()-1; i>=0; i--){
		var mi=pm.getComponent(i);
		if (!(mi instanceof javax.swing.JMenuItem)){
			continue;
		}
		for (j=0; j<ra.length; j++) {
			if (mi.getText().startsWith(ra[j][0])){
				if (ra[j][1]>0){ //サブメニューがある
					if (!ra[j][2]) { // サブメニューありでも、親が非表示なら親を削除
						pm.remove(i);
					} else {
						l=ra2[ra[j][1]].length-1;
						for (k=mi.getItemCount()-1; k>=0; k--){
							var mj=mi.getItem(k);
							if (!(mj instanceof javax.swing.JMenuItem)) {
								continue;
							}
							if (mj.getText().startsWith(ra2[ra[j][1]][l][0])) {
								if (!ra2[ra[j][1]][l][1]) {
									mi.remove(k);
								}
								l--;
							}
						}
						removeRedundantSeparatorSub(mi);
					}
				} else { //サブメニューがない
					if (!ra[j][2]) {
						pm.remove(i);
					}
				}
			}
		}
	}
	removeRedundantSeparator(pm);
}
// 余分なセパレータ削除
function removeRedundantSeparator(pm){
	var bs0=true;
	for (var i=pm.getComponentCount()-1; i>=0; i--) {
		var bs=!(pm.getComponent(i) instanceof javax.swing.JMenuItem);
		if (bs&&bs0) {
			pm.remove(i);
		}
		bs0 = bs;
	}
	if ((pm.getComponentCount()>0)&&!(pm.getComponent(0) instanceof javax.swing.JMenuItem)) {
		pm.remove(0);
	}
}
// 余分なセパレータ削除(サブメニュー用)
function removeRedundantSeparatorSub(mi){
	var bs0=true;
	for (var l=mi.getItemCount()-1; l>=0; l--) {
		var bs=!(mi.getItem(l) instanceof javax.swing.JMenuItem);
		if (bs&&bs0) {
			mi.remove(l);
		}
		bs0 = bs;
	}
	if ((mi.getItemCount()>0)&&!(mi.getItem(0) instanceof javax.swing.JMenuItem)) {
		mi.remove(0);
	}
}
// ----- 前の行まで -----